#! /usr/bin/octave -qf

###
## Blocked Jacobi
###

if (length(argv) != 4)
	printf("./bjacobi.m [Matrix A] [Vector B] [Vector X] [Block size]\n");
	quit
endif

MAX_ITER = 1000;
MT = spconvert(load(argv(){1}));
B = load(argv(){2});
X1 = load(argv(){3});
BS = str2num(argv(){4});
DIM = rows(MT);
##Calculate the true result
X = linsolve(MT, B);

printf("Dim = %d\n", DIM);

X0 = zeros(length(X), 1);

for iter = 1 : MAX_ITER
	Xtmp = zeros(length(X), 1);
	for i = 1 : BS : DIM
		for j = 1 : BS : DIM
			if ( i != j )
				Xtmp(i:i+BS-1,:) += MT(i:i+BS-1,j:j+BS-1) * X0(j:j+BS-1,:);
			endif
		endfor
		Xtmp(i:i+BS-1,:) = B(i:i+BS-1,:) - Xtmp(i:i+BS-1,:);
		LL = chol(MT(i:i+BS-1,i:i+BS-1),"lower");
		LU = chol(MT(i:i+BS-1,i:i+BS-1),"upper");
		X0(i:i+BS-1,:) = linsolve(LL, Xtmp(i:i+BS-1,:));
		X0(i:i+BS-1,:) = linsolve(LU, X0(i:i+BS-1,:));
	endfor
endfor

#printf("norm x: %e\t norm x0: %e\n", norm(X), norm(X0));
printf("(n-n0)/n0: %e\n", abs(norm(X0)-norm(X))/norm(X));

aa = norm(B - MT * X); #True value (octave)
bb = norm(B - MT * X0); #Result
cc = norm(B - MT * X1); #True Value (c)
printf("B-A*x: %e\nB-A*x0: %e\nB-A*x1: %e\n", aa, bb, cc);
