#!/bin/bash
#BSUB -J cgbau_test
#BSUB -W 01:00
#BSUB -q debug
#BSUB -oo cgbau_test_%J.out
#BSUB -eo cgbau_test_%J.err
#BSUB -n 1

module load ompss mkl LAPACK EXTRAE
export LD_LIBRARY_PATH=/apps/OCTAVE/3.8.0/lib:$LD_LIBRARY_PATH
export PATH=/apps/OCTAVE/3.8.0/bin:/home/bsc19/bsc19732/bin:$PATH

export NX_PES=16

for i in $( seq 1 1000 ) ; do 
	./cgbau 1024 128 1 1 1 16 1e-16 &> bla  

	nrm=$( 2norm.sh x.mm xstar.mm ) 
	if [ $? -ne 0 ]; then
		exit 1
	fi
	if [ "${nrm}" == "NaN" ]; then
		exit 2;
	fi

	echo ${nrm}

	rm -f bla
done ;
