#!/bin/bash
#BSUB -J cgbau_async
#BSUB -W 08:00
#BSUB -q seq
#BSUB -oo cgbau_async_%J.out
#BSUB -eo cgbau_async_%J.err
#BSUB -n 1

module load ompss mkl LAPACK EXTRAE
export LD_LIBRARY_PATH=/apps/OCTAVE/3.8.0/lib:$LD_LIBRARY_PATH
export PATH=/apps/OCTAVE/3.8.0/bin:/home/bsc19/bsc19732/bin:$PATH

for n in 2048 4096 8192 16384; do

	for pe in $( seq 4 4 16 ); do 

		export NX_PES=${pe}

		for it in $( seq 1 100 ); do

			NX_ARGS="--schedule=bf --schedule-priority" ./cgbau_async ${n} 256 1 1 1 16 1> /dev/null

			echo -n "n ${n} pe ${pe} it ${it} "
			date 

		done
	done
done
