#!/bin/bash
#BSUB -J refine_16384
#BSUB -W 02:00
#BSUB -q sequential
#BSUB -oo refine_%J.out
#BSUB -eo refine_%J.err
#BSUB -n 1
#BSUB -x

module load ompss MKL 
#export LD_LIBRARY_PATH=/apps/OCTAVE/3.8.0/lib:$LD_LIBRARY_PATH
#export PATH=/apps/OCTAVE/3.8.0/bin:/home/bsc19/bsc19732/bin:$PATH

for n in 16384 ; do

	for pe in $( seq 1 16 ); do 

		export NX_PES=${pe}

		for it in $( seq 1 1 ); do

			#use: ./itref n bm bn s refit cgit [maxcgit] [prec] [rep] [dupl] [errnrm]
			NX_ARGS="--schedule=bf --schedule-priority" /home/bsc19/bsc19732/apps/cg/build/bin/itref ${n} 256 1 1 128 1 4 1e-16 1 3 > itref.log
			
			fname="MN_pe${pe}_it${it}_covar_${n}_256_1_1_128_1_4_1e-16_1_3"

			mv itref.log "${fname}.log"
			mv rt.data "${fname}.rt.data"
			mv rhs.mm "${fname}.rhs.mm"

		done
	done
done
