function x = cg_saad(A, b, x, maxit=0, f=[])


[m,n] = size(A);
r = b - A * x;
p = r;
rho = transpose(r) * r;
tol = sqrt(rho);

if maxit==0
	maxit=n;
end

i=0;

while i<maxit && tol>1e-6 
	t = A * p;

	tp = transpose(t) * p;
	tt = transpose(t) * t;

	alpha = rho / tp;
	beta = ( rho * tt / (tp * tp) ) - 1;
	rho = rho * beta;

	x += alpha * p;
	r -= alpha * t;
	p = r + beta *p;

	tol = sqrt( transpose(r) * r );
	printf("%i %16.20e %16.20e %16.20e\n", i, tol, alpha, beta);
	
	%anorm = sqrt(transpose(x - f) * A * (x-f));
	i = i+1;
end
