## usage: x = cgbau (A, b, x, maxit=0, rtol=1e-16, f=[])


function x = cgbau(A, b, x, maxit=0, rtol=1e-16, f=[])


[m,n] = size(A);
r = b - A * x;
p = r;

if maxit==0
	maxit=n;
end

i=0;
tol = sqrt( transpose(r) * r );

while i<maxit && tol>rtol
	t = A * p;

	u = transpose(r) * r;
	zeta = transpose(p) * t;
	alpha = u / zeta;
	x += alpha * p;
	r -= alpha * t;
	tol = transpose(r) * r;
	beta = tol / u;
	p = r + beta *p;

	tol = sqrt(tol);
	printf("%i %16.20e    %16.20e = %16.20e / %16.20e    %16.20e\n", i, tol, alpha, u, zeta, beta);
	
	%anorm = sqrt(transpose(x - f) * A * (x-f));
	i = i+1;
end
