## usage: x = cgpipe (A, b, x, maxit=0, rtol=1e-16, f=[])


function x = cgpipe(A, b, x, maxit=0, rtol=1e-16, f=[])


[m,n] = size(A);
r = b - A * x;
p = r;
w = A * r;

if maxit==0
	maxit=n;
end

i=0;
tol = sqrt( transpose(r) * r );
gamma = 0;
alpha = 0;
z = zeros(m,1);
s = zeros(m,1);
p = zeros(m,1);

while i<maxit && tol>rtol
	prevgamma = gamma;
	prevalpha = alpha;
	gamma = transpose(r) * r;
	delta = transpose(w) * r;

	q = A * w;

	if i > 0
		beta = gamma / prevgamma; 
		alpha = gamma / ( delta - beta * gamma / prevalpha ); 
	else
		beta = 0.0; 
		alpha = gamma / delta;
	end 

	%printf("gamma %f delta %f alpha %f\n", gamma, delta, alpha);

	z = q + beta * z;
	s = w + beta * s;
	p = r + beta * p;
	x = x + alpha * p;
	r = r - alpha * s;
	w = w - alpha * z;

	tol = sqrt(gamma);
	printf("%i %16.20e\n", i, tol);
	
	i = i+1;
end
