## usage: A = covariant(n, p, k)

function A = covariant(n, p, k)

	if p <= 0
		printf("err: a covariant matrix requires p > 0\n")
		A=[];
		return
	end 

	A = zeros(n, n);


	mp = -p;                                                                                                                                                                 
    kinv = 1 / k;                                                                                                                                                            
                                                                                                                                                                                      
	for j=1:n

		for i=1:j-1
			A(i,j) = (j-i) ** mp;                                                                                                                                     
		end
                                                                                                                                                                                      
		A(j,j) = 1 + (j) ** kinv;                                                                                                                                       
                                                                                                                                                                                      
		for i=j+1:n
			A(i,j) = (i-j) ** mp;                                                                                                                                     
		end
	end
                       
	A = sparse(A);

end
