## usage: x = scgbau (A, b, x, maxit=0, rtol=1e-16, f=[])


function x = scgbau(A, b, x, maxit=0, rtol=1e-16, f=[])


[m,n] = size(A);
A = single(full(A));
b = single(b);
x = single(x);

r = single(b - A * x);
p = single(r);

if maxit==0
	maxit=n;
end

i=0;
tol = single(sqrt( transpose(r) * r ));

while i<maxit && tol>rtol
	t = single(A * p);

	u = single(transpose(r) * r);
	alpha = single(u / ( transpose(p) * t ));
	x += single(alpha * p);
	r -= single(alpha * t);
	tol = single(transpose(r) * r);
	beta = single(tol / u);
	p = single(r + beta *p);

	tol = single(sqrt(tol));
	printf("%i %16.20e %16.20e %16.20e\n", i, tol, alpha, beta);
	
	%anorm = sqrt(transpose(x - f) * A * (x-f));
	i = i+1;
end
