#include "task_csrmm.h"


#include "fptype.h"
#include "fpsblas.h"
#include "selfsched.h"
#include "task_csrmmb.h"
#include "matfprint.h"


#ifdef SINGLE_PRECISION

#define _t_csrmm_sched		task_scsrmm_sched

#else

#define _t_csrmm_sched		task_dcsrmm_sched

#endif


void _t_csrmm_sched(int cnt, int b, int c, int d, fp_t alpha, int *vptr, int *vpos, hbmat_t **vval, fp_t *B, int ldb, fp_t beta, fp_t *C, int ldc, selfsched_t *sched)
{
	if ( cnt > 0 ) {
		hbmat_t *Ahb = vval[0];
		int offs = vpos[0];	

		TASK_CSRMMB(c, alpha, "GLNF", Ahb, B + offs * d, ldb, beta, C, ldc, 0, sched);

		int k;
		for ( k = 1; k < cnt-1; ++k ) {
			hbmat_t *Ahb = vval[k];
			int offs = vpos[k];	

			TASK_CSRMMB(c, alpha, "GLNF", Ahb, B + offs * d, ldb, FP_ONE, C, ldc, k, sched);
		}

		int lst = cnt - 1;
		if ( lst > 0 ) {
			hbmat_t *Ahb = vval[lst];
			int offs = vpos[lst];	

			TASK_CSRMMB(c, alpha, "GLNF", Ahb, B + offs * d, ldb, FP_ONE, C, ldc, lst, sched);
		}
	}

#pragma omp taskwait
}

