#ifndef __TASK_CSRMM_H__
#define __TASK_CSRMM_H__


#include "hb.h"
#include "selfsched.h"


#ifdef SINGLE_PRECISION

#define TASK_CSRMM_SCHED task_scsrmm_sched

#else

#define TASK_CSRMM_SCHED task_dcsrmm_sched

#endif


#define LIBSBBLAS_EXPORT __attribute__((__visibility__("default")))


#pragma omp task in([d*c]B) inout([b*c]C)
extern LIBSBBLAS_EXPORT void task_scsrmm_sched(int cnt, int b, int c, int d, float alpha, int *vptr, int *vpos, hbmat_t **vval, float *B, int ldb, float beta, float *C, int ldc, selfsched_t *sched);


#pragma omp task in([d*c]B) inout([b*c]C)
extern LIBSBBLAS_EXPORT void task_dcsrmm_sched(int cnt, int b, int c, int d, double alpha, int *vptr, int *vpos, hbmat_t **vval, double *B, int ldb, double beta, double *C, int ldc, selfsched_t *sched);


#endif // __TASK_CSRMM_H__
