#include "cg_config.h"

#include "fptype.h"

#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>



extern int n;
extern int bm;
extern int bn;
extern int s;
extern int it;
extern double prec;
extern int lookahead; 
extern int async;
extern int rep;
extern char *rhsfname;
extern char *aname;
extern double profile;
extern int warmup;

extern int refit;
extern int release;
extern double orth_fac;


int itref_config(int argc, char *argv[]) 
{
	if ( argc < 6) {
		fprintf(stderr, "use: %s n bm bn s refit [it] [prec] [lookahead] [async] [profile] [rep] [warmup] [release] [orth_fac] [B] [A]\n", argv[0]);
		return 1;
	}

	n = atoi(argv[1]);
	bm = atoi(argv[2]);
	bn = atoi(argv[3]);
	s = atoi(argv[4]);
	if ( bn > s ) {
		bn = s;
		fprintf(stderr, "warn: bn too large, resetting to %i\n", s);
	}
	refit = atoi(argv[5]);

	it = n;
	prec = -1.0;
	rep = 1;
	lookahead = 0;
	async = 0;
	profile = 1.0;
	warmup = 0;
	release = 1;
	rhsfname = NULL;
	aname = NULL;
	orth_fac = 1.0;

	if ( argc > 6 ) {
		it = atoi(argv[6]);
		if ( it > n ) {
			fprintf(stderr, "warn: setting it to %i\n", n);
			it = n;
		}
		if ( argc > 7 ) {
			prec = atof(argv[7]);
			if ( argc > 8 ) {
				lookahead = atoi(argv[8]);
				if ( argc > 9 ) {
					async = atoi(argv[9]);

					if ( argc > 10 ) {
						profile  = atof(argv[10]);
						if ( profile <= 0.0 ) {
							fprintf(stderr, "warn: setting profile to 1.0\n");
							profile = 1.0;
						}

						if ( profile != 1.0 && async == 0 ) {
							fprintf(stderr, "warn: profiling requires async\n");
							profile = 1.0;
						}
			
						if ( argc > 11 ) {
							rep  = atoi(argv[11]);

							if ( argc > 12 ) {
								warmup = atoi(argv[12]);

								if ( argc > 13 ) {
									release = atoi(argv[13]);
									if ( argc > 14 ) {
										orth_fac = atof(argv[14]);
										if ( argc>15) {
											rhsfname = argv[15];
											if ( argc > 16 ) {
												aname = argv[16];
											}
										}
									}
								}
							}
						}
					}
				}
			}
		}
	}

	printf("n %i bm %i bn %i s %i refit %i it %i prec %.16e lookahead %i async %i profile %e rep %i warmup %i release %d orth_fac: %e B %s A: %s\n", n, bm, bn, s, refit, it, prec, lookahead, async, profile, rep, warmup, release, orth_fac, rhsfname, aname);

	if ( profile != 1.0 || async == 1 ) {
		printf("warn: don't forget schedule=bf and schedule-priority!\n");
	}

	return 0;
}
